xfs: Check for extent overflow when growing realtime bitmap/summary inodes

Verify that XFS does not cause realtime bitmap/summary inode fork's
extent count to overflow when growing the realtime volume associated
with a filesystem.

Reviewed-by: Darrick J. Wong <djwong@kernel.org>
Reviewed-by: Allison Henderson <allison.henderson@oracle.com>
Signed-off-by: Chandan Babu R <chandanrlinux@gmail.com>
This commit is contained in:
Chandan Babu R
2021-03-09 10:31:16 +05:30
committed by Eryu Guan
parent 9f8584434b
commit d9d2de11ef
3 changed files with 136 additions and 0 deletions
Executable
+124
View File
@@ -0,0 +1,124 @@
#! /bin/bash
# SPDX-License-Identifier: GPL-2.0
# Copyright (c) 2021 Chandan Babu R. All Rights Reserved.
#
# FS QA Test 530
#
# Verify that XFS does not cause bitmap/summary inode fork's extent count to
# overflow when growing an the realtime volume of the filesystem.
#
seq=`basename $0`
seqres=$RESULT_DIR/$seq
echo "QA output created by $seq"
here=`pwd`
tmp=/tmp/$$
status=1 # failure is the default!
trap "_cleanup; exit \$status" 0 1 2 3 15
_cleanup()
{
cd /
_scratch_unmount >> $seqres.full 2>&1
test -e "$rtdev" && losetup -d $rtdev >> $seqres.full 2>&1
rm -f $tmp.* $TEST_DIR/$seq.rtvol
}
# get standard environment, filters and checks
. ./common/rc
. ./common/filter
. ./common/inject
. ./common/populate
# remove previous $seqres.full before test
rm -f $seqres.full
# real QA test starts here
_supported_fs xfs
# Note that we don't _require_realtime because we synthesize a rt volume
# below.
_require_test
_require_xfs_debug
_require_test_program "punch-alternating"
_require_xfs_io_error_injection "reduce_max_iextents"
_require_xfs_io_error_injection "bmap_alloc_minlen_extent"
_require_scratch_nocheck
echo "* Test extending rt inodes"
_scratch_mkfs | _filter_mkfs >> $seqres.full 2> $tmp.mkfs
. $tmp.mkfs
echo "Create fake rt volume"
nr_bitmap_blks=25
nr_bits=$((nr_bitmap_blks * dbsize * 8))
# Realtime extent size has to be atleast 4k in size.
if (( $dbsize < 4096 )); then
rtextsz=4096
else
rtextsz=$dbsize
fi
rtdevsz=$((nr_bits * rtextsz))
truncate -s $rtdevsz $TEST_DIR/$seq.rtvol
rtdev=$(_create_loop_device $TEST_DIR/$seq.rtvol)
echo "Format and mount rt volume"
export USE_EXTERNAL=yes
export SCRATCH_RTDEV=$rtdev
_scratch_mkfs -d size=$((1024 * 1024 * 1024)) -b size=${dbsize} \
-r size=${rtextsz},extsize=${rtextsz} >> $seqres.full
_try_scratch_mount || _notrun "Couldn't mount fs with synthetic rt volume"
echo "Consume free space"
fillerdir=$SCRATCH_MNT/fillerdir
nr_free_blks=$(stat -f -c '%f' $SCRATCH_MNT)
nr_free_blks=$((nr_free_blks * 90 / 100))
_fill_fs $((dbsize * nr_free_blks)) $fillerdir $dbsize 0 >> $seqres.full 2>&1
echo "Create fragmented filesystem"
for dentry in $(ls -1 $fillerdir/); do
$here/src/punch-alternating $fillerdir/$dentry >> $seqres.full
done
echo "Inject reduce_max_iextents error tag"
_scratch_inject_error reduce_max_iextents 1
echo "Inject bmap_alloc_minlen_extent error tag"
_scratch_inject_error bmap_alloc_minlen_extent 1
echo "Grow realtime volume"
$XFS_GROWFS_PROG -r $SCRATCH_MNT >> $seqres.full 2>&1
if [[ $? == 0 ]]; then
echo "Growfs succeeded; should have failed."
exit 1
fi
_scratch_unmount >> $seqres.full
echo "Verify rbmino's and rsumino's extent count"
for rtino in rbmino rsumino; do
ino=$(_scratch_xfs_get_metadata_field $rtino "sb 0")
echo "$rtino = $ino" >> $seqres.full
nextents=$(_scratch_get_iext_count $ino data || \
_fail "Unable to obtain inode fork's extent count")
if (( $nextents > 10 )); then
echo "Extent count overflow check failed: nextents = $nextents"
exit 1
fi
done
echo "Check filesystem"
_check_xfs_filesystem $SCRATCH_DEV none $rtdev
losetup -d $rtdev
rm -f $TEST_DIR/$seq.rtvol
# success, all done
status=0
exit
+11
View File
@@ -0,0 +1,11 @@
QA output created by 530
* Test extending rt inodes
Create fake rt volume
Format and mount rt volume
Consume free space
Create fragmented filesystem
Inject reduce_max_iextents error tag
Inject bmap_alloc_minlen_extent error tag
Grow realtime volume
Verify rbmino's and rsumino's extent count
Check filesystem
+1
View File
@@ -506,3 +506,4 @@
527 auto quick quota
528 auto quick rw realtime
529 auto quick quota
530 auto quick realtime growfs